# -*- coding: UTF-8 -*-
from __future__ import absolute_import
from __future__ import print_function

import sys
import difflib
from six.moves import html_parser
from six.moves.urllib.parse import quote_plus, urlencode
import urllib.request
import urllib.parse
import html
import urllib3
import requests, json, re, random, string, time, warnings
from requests.packages.urllib3.exceptions import InsecureRequestWarning
warnings.simplefilter('ignore',InsecureRequestWarning)
import os, os.path
from six.moves.urllib.request import HTTPCookieProcessor, build_opener, install_opener, Request, urlopen, FancyURLopener
from six.moves import http_cookiejar
from ..utilities import languageTranslate, log, getFileSize
from urllib import request, parse
from urllib.parse import urlencode
import six
from six.moves import urllib
from six.moves import xmlrpc_client
import calendar
from ..seeker import SubtitlesDownloadError, SubtitlesErrors

PY3 = False
if sys.version_info[0] == 3:
    from urllib.request import urlopen, Request
    PY3 = True
else:
    from urllib2 import urlopen, Request
    from urllib3 import urlopen, Request


if sys.version_info[0] == 3:
    from urllib.parse import quote  # Python 3
else:
    from urllib import quote  # Python 2
    from urllib3 import quote 


try:
    from urllib import unquote
except ImportError:
    from urllib.parse import unquote

HDR= {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; rv:109.0) Gecko/20100101 Firefox/115.0',
      'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
      'Accept-Language': 'fr,fr-FR;q=0.8,en-US;q=0.5,en;q=0.3',
      'Content-Type': 'text/html; charset=UTF-8',
      'Host': 'subs.ath.cx',
      'Referer': 'http://subs.ath.cx',
      'Upgrade-Insecure-Requests': '1',
      'Connection': 'keep-alive',
      'Accept-Encoding':'gzip, deflate'}#, deflate'}
      
s = requests.Session()   

main_url = "http://subs.ath.cx"
debug_pretext = "subs.ath.cx"


def get_url(url, referer=None):
    if referer is None:
        headers = {'User-agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:6.0) Gecko/20100101 Firefox/6.0'}
    else:
        headers = {'User-agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:6.0) Gecko/20100101 Firefox/6.0', 'Referer': referer}
    req = urllib.request.Request(url, None, headers)
    response = urllib.request.urlopen(req)
    content = response.read().decode('utf-8') 
    response.close()
    content = content.replace('\n', '')
    return content


def get_rating(downloads):
    rating = int(downloads)
    if (rating < 50):
        rating = 1
    elif (rating >= 50 and rating < 100):
        rating = 2
    elif (rating >= 100 and rating < 150):
        rating = 3
    elif (rating >= 150 and rating < 200):
        rating = 4
    elif (rating >= 200 and rating < 250):
        rating = 5
    elif (rating >= 250 and rating < 300):
        rating = 6
    elif (rating >= 300 and rating < 350):
        rating = 7
    elif (rating >= 350 and rating < 400):
        rating = 8
    elif (rating >= 400 and rating < 450):
        rating = 9
    elif (rating >= 450):
        rating = 10
    return rating


def search_subtitles(file_original_path, title, tvshow, year, season, episode, set_temp, rar, lang1, lang2, lang3, stack): #standard input
    subtitles_list = []
    msg = ""
    title = str(title).replace(':', '').replace('  ', ' ').replace(',', '').replace("'", "").replace("&", "and").replace("!", "").replace("?", "").replace("- ", "").replace(" III", " 3").replace(" II", " 2").title()
    if len(tvshow) == 0 and year: # Movie
        searchstring = "%s (%s)" % (title, year)
    elif len(tvshow) > 0 and title == tvshow: # Movie not in Library
        searchstring = "%s (%#02d%#02d)" % (tvshow, int(season), int(episode))
    elif len(tvshow) > 0: # TVShow
        searchstring = "%s S%#02dE%#02d" % (tvshow, int(season), int(episode))
    else:
        searchstring = title
    log(__name__, "%s Search string = %s" % (debug_pretext, searchstring))
    get_subtitles_list(title, searchstring, "ar", "Arabic", subtitles_list)
    return subtitles_list, "", msg #standard output


def download_subtitles(subtitles_list, pos, zip_subs, tmp_sub_dir, sub_folder, session_id): #standard input
    language = subtitles_list[pos]["language_name"]
    id = subtitles_list[pos]["id"]
    #id = re.compile('(.+?.+?)/').findall(id)[-1]
    downloadlink = 'http://subs.ath.cx/subtitles/%s' % (id)
    #id = 'http://www.findsubtitles.eu/getp.php?id=%s' % (id)
    print(downloadlink)   
    if downloadlink:
        log(__name__ , "%s Downloadlink: %s " % (debug_pretext, downloadlink))
        viewstate = 0
        previouspage = 0
        subtitleid = 0
        typeid = "zip"
        filmid = 0
        postparams = { '__EVENTTARGET': 's$lc$bcr$downloadLink', '__EVENTARGUMENT': '' , '__VIEWSTATE': viewstate, '__PREVIOUSPAGE': previouspage, 'subtitleId': subtitleid, 'typeId': typeid, 'filmId': filmid}
        #postparams = urllib3.request.urlencode({ '__EVENTTARGET': 's$lc$bcr$downloadLink', '__EVENTARGUMENT': '' , '__VIEWSTATE': viewstate, '__PREVIOUSPAGE': previouspage, 'subtitleId': subtitleid, 'typeId': typeid, 'filmId': filmid})
        #class MyOpener(urllib.FancyURLopener):
            #version = 'User-Agent=Mozilla/5.0 (Windows NT 6.1; rv:109.0) Gecko/20100101 Firefox/115.0'
        #my_urlopener = MyOpener()
        #my_urlopener.addheader('Referer', url)
        log(__name__ , "%s Fetching subtitles using url with referer header '%s' and post parameters '%s'" % (debug_pretext, downloadlink, postparams))
        #response = my_urlopener.open(downloadlink, postparams)
        response = s.get(downloadlink,data=postparams,headers=HDR,verify=False,allow_redirects=True) 
        print(response.content)
        local_tmp_file = zip_subs
        try:
            log(__name__ , "%s Saving subtitles to '%s'" % (debug_pretext, local_tmp_file))
            if not os.path.exists(tmp_sub_dir):
                os.makedirs(tmp_sub_dir)
            local_file_handle = open(local_tmp_file, 'wb')
            local_file_handle.write(response.content)
            local_file_handle.close()
            # Check archive type (rar/zip/else) through the file header (rar=Rar!, zip=PK) urllib3.request.urlencode
            myfile = open(local_tmp_file, "rb")
            myfile.seek(0)
            if (myfile.read(1).decode('utf-8') == 'R'):
                typeid = "rar"
                packed = True
                log(__name__ , "Discovered RAR Archive")
            else:
                myfile.seek(0)
                if (myfile.read(1).decode('utf-8') == 'P'):
                    typeid = "zip"
                    packed = True
                    log(__name__ , "Discovered ZIP Archive")
                else:
                    typeid = "srt"
                    packed = False
                    subs_file = local_tmp_file
                    log(__name__ , "Discovered a non-archive file")
            myfile.close()
            log(__name__ , "%s Saving to %s" % (debug_pretext, local_tmp_file))
        except:
            log(__name__ , "%s Failed to save subtitle to %s" % (debug_pretext, local_tmp_file))
        if packed:
            subs_file = typeid
        log(__name__ , "%s Subtitles saved to '%s'" % (debug_pretext, local_tmp_file))
        return packed, language, subs_file  # standard output

def get_subtitles_list(title, searchstring, languageshort, languagelong, subtitles_list):
    url = '%s/subtitles' % (main_url) 
    title = title.strip()
    
    #url = 'https://archive.org/download/iptvworld-1/A/'  quote_plus(title)
    d = quote_plus(title)
    d = d.replace('+', '.')
    print('url', url)
    print('d', d)
    print('searchstring', searchstring)
    try:
        log(__name__, "%s Getting url: %s" % (debug_pretext, url))
        content = s.get(url,headers=HDR,verify=False,allow_redirects=True).text
        #print(content)  
    except:
        pass
        log(__name__, "%s Failed to get url:%s" % (debug_pretext, url))
        return
    try:
        log( __name__ ,"%s Getting '%s' subs ..." % (debug_pretext, languageshort))
        subtitles = re.compile(r'(<td><a href.+?">'+d+'.+?</a></td>)', re.IGNORECASE).findall(content)
        #print(subtitles)                        
    except:
        log( __name__ ,"%s Failed to get subtitles" % (debug_pretext))
        return
    for subtitle in subtitles:
        try:
            filename = re.compile('<td><a href=".+?">(.+?)</a></td>').findall(subtitle)[0]
            filename = filename.strip().replace('.srt', '')
            #print(filename) 
            id = re.compile('href="(.+?)"').findall(subtitle)[0]
            #print(id) 
            if not (filename == 'Εργαστήρι Υποτίτλων' or filename == 'subs4series'):
                log( __name__ ,"%s Subtitles found: %s (id = %s)" % (debug_pretext, filename, id))
                subtitles_list.append({'no_files': 1, 'filename': filename, 'sync': True, 'id' : id, 'language_flag': 'flags/' + languageshort + '.gif', 'language_name': languagelong})
        except:
            pass
    return
